<?php

/**
 * Dies Klasse stellt funktionalität zur Verfügung,
 * um zu ermitteln, ob bei einem String ein möglicher
 * SQL Injection Versuch vorliegt.
 */
class SQLInjectionTester{
	
	/**
	 * Überprüfen, ob die Eingabe ein Kommentar
	 * ist, oder ein Semikolon enthält
	 * @param String $query Zu überprüfender String
	 * @return bool true, wenn der Eingabe-String OK ist.
	 */
	public static function checkStatement($query){
		if (SQLInjectionTester::check($query)){
			return SQLInjectionTester::check4Identical($query);
		} else {
			return false;
		}
	}
	
	/**
	 * Überprüfen, ob die Eingabe (Teil eines SQLs) ein Kommentar
	 * ist, oder ein Semikolon enthält
	 * @param String $input Zu überprüfender String
	 * @return bool true, wenn der Eingabe-String OK ist.
	 */
	public static function checkInput($input){
		if (SQLInjectionTester::check($input)){
			return SQLInjectionTester::check4Identical($input);
		} else {
			return false;
		}
				}
	
	/**
	 * Überprüfen, ob ein Teil des Strings ein Kommentar
	 * ist, oder ein Semikolon enthält
	 * @param String $string Zu überprüfender String
	 * @return bool true, wenn der Eingabe-String OK ist.
	 */
	private static function check($string){
		if (strpos($string, "--")){
			return false;
		}
		if (strpos($string, "/*")){
			return false;
		}
		if (strpos($string, ";")){
			return false;
		}
		return true;
	}
	
	/**
	 * Überprüfen, dass keine Abfragen der Form id=id
	 * möglich sind.
	 * @param String $input Zu überprüfender String
	 * @return bool true, wenn der Eingabe-String OK ist.
	 * 	 */
	private static function check4Identical($input){
		$parts2 = explode(" ", $input);
		$parts = array();
		for($i=count($parts2)-1;$i>=0;$i--){
			if (!strlen(trim($parts2[$i]))==0){
				array_push($parts,$parts2[$i]);
			}
		}
		for($i=1;$i<count($parts)-1;$i++){
			if (strpos($parts[$i],"=")!==false && strlen($parts[$i])==1){
				// Vergleiche Teil vor '=' mit Teil nach dem '='
				$befor =$parts[$i-1];
				$after = $parts[$i+1];
				$befor = str_replace("`","",$befor);
				$befor = str_replace("'","",$befor);
				$after = str_replace("`","",$after);
				$after = str_replace("'","",$after);
				if ($befor==$after){
					return false;
				}
			}
		}
		return true;
	}
}
?>